import java.util.*;
import org.bleb.paperboy.plugin.*;
import org.bleb.paperboy.web.*;
import org.bleb.paperboy.util.*;

/**
 * A plugin for the <a href="http://news.bbc.co.uk">BBC Online</a>,
 * the BBC's <em>premiere</em> online news service.
 *
 * @author Andrew Flegg
 * @version 0.01 (07-Mar-2000)
 **/
public class PluginBBC extends Plugin
{
    private static String HOST = "http://news.bbc.co.uk";
    private static String PATH = "/low/english/";

    public void start(OptionConfig conf) throws Exception
    {
        Webpage     site  = new Webpage();
        HTMLBlock   index = new HTMLBlock();
        Enumeration enum  = ((Vector)conf.getItem( "sections"
                                                   ).getValue()).elements();
        Story       current;
        this.stories      = new Vector();

        while (enum.hasMoreElements()) {
            OptionBoolean i = (OptionBoolean)enum.nextElement();
            if ( ((Boolean)i.getValue()).booleanValue()) {
                // -- Get the index ------------------------------------
                site.setURL(HOST + PATH + i.getName() + "/default.stm");
                site.connect();
                index.setString(site.getContent());
                site.close();

                // -- Process the index --------------------------------
                index.crop("<!--NOLIndexBody-->",
                           "<a href=\"/text_only.stm\"", false);

                while (index.containsIgnoreCase("<br> <a ")) {
                    index.moveToIgnoreCase("<br> <a ",true);
                    index.removeStart();
                    String u = (String)index.getNextTag("a").get("href");
                    if (u.indexOf("/"+i.getName().toLowerCase()+"/") == -1) {
                        DEBUG.println("PluginBBC.start: "+u+
                                      " isn't in " +i.getName());
                        continue;
                    }

                    current = new Story(HOST + "/hi" + u.substring(4));
                    current.setSection( "BBC : " + i.getLabel() );

                    index.removeStart();
                    index.moveToIgnoreCase("</a>", true);
                    current.setHeadline( index.removeStart() );

                    if (current.getHeadline().startsWith("<")) {
                        index.moveToIgnoreCase("<br> <a ", false);
                        index.moveToIgnoreCase(">", false);
                        index.removeStart();
                        index.moveToIgnoreCase("</a>", true);
                        current.setHeadline( index.removeStart() );
                    }
                        
                    index.moveToIgnoreCase("<br>", false);
                    index.removeStart();
                    index.moveToIgnoreCase("<br>", true);
                    current.setSummary( index.removeStart() );

                    stories.add(current);
                }
            }
        }
        return;
    }


    /**
     * Fetch the rest of the Story so we've got all the content.
     *
     * @param s Story to update
     **/
    public void fetch(Story s) throws Exception
    {
        HTMLBlock page = new HTMLBlock(s.getData());

        page.crop("<font face=\"sans-serif\" size=\"2\">",
                  "<td><img src=\"/furniture/nothing.gif\"", false);

        page.resetPosition();
        while(page.replace("<HR>", "<br><hr><br>"));

        page.resetPosition();
        while(page.replace(" CLASS=\"*\"", ""));

        s.setData( page.toString() );
        s.setLastModified( (new Date()).getTime() );
        return;
    }
}










