package org.bleb.paperboy;

import org.bleb.paperboy.util.*;

/**
 * Use the Testable interface to ensure that components of the system are
 * working properly, reporting any errors found.
 *
 * @version 0.50 (07-Jan-2000)
 **/
public class Test
{
    public static void main(String argv[])
    {
        DEBUG.setState(false);
        
        Testable toTest[] = {
                              new org.bleb.paperboy.web.HTMLBlock(),
                              new org.bleb.paperboy.util.FileOutput(),
                              new org.bleb.paperboy.util.Codecs(),
//                              new org.bleb.paperboy.web.Webpage()
                            };
                         
        boolean status    = true;
        boolean thisStatus;
        
        System.err.println("\nTesting Paperboy at " +
                           new java.util.Date().toString() + "...\n" +
                             "================\n");
        for(int i=0; i<toTest.length; i++) {
            System.err.print( "+ " + toTest[i].getClass().getName() + "\t");
            thisStatus = toTest[i].test();
            status = (status & thisStatus);
            if (! thisStatus) {
                System.err.println("\\ FAILED");
            }
        }
        
        System.err.println(status ? "\nAll tests completed successfully." :
                                    "\nSome tests have failed. See above for details.");

        System.err.println();
        return;
    }
}
        
