package org.bleb.paperboy.gui;

import org.bleb.paperboy.plugin.*;
import org.bleb.paperboy.util.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.*;

/**
 * Miscellaneous options management, eg. proxy settings,
 * command to run for external stuff.
 *
 * @version 0.01 (08-Mar-2000)
 **/
public class MiscConfigFrame implements ActionListener
{
    protected JFrame      window;
    protected JPanel      pane;
    protected JButton     save;
    protected JButton     cancel;

    public MiscConfigFrame()
    {
        super();
        Border bigGap = BorderFactory.createEmptyBorder(12, 12, 12, 12);
        Border midGap = BorderFactory.createEmptyBorder(8, 8, 8, 8);

        JComponent cfg = Config.getConfig().getComponent();
        window = new JFrame("Miscellaneous Configuration");
        pane   = new JPanel();
        pane.add(cfg);
        pane.setBorder(new CompoundBorder(bigGap,
                                          BorderFactory.createRaisedBevelBorder()));
        cfg.setPreferredSize(new Dimension(460, 300));

        JPanel box = new JPanel();
        box.setLayout(new BoxLayout(box, BoxLayout.X_AXIS));
        box.setBorder(midGap);

        save   = new JButton("Save");
        cancel = new JButton("Close");

        save.addActionListener(this);
        cancel.addActionListener(this);

        save.setActionCommand("save");
        cancel.setActionCommand("cancel");

        save.setMaximumSize(cancel.getPreferredSize());
        cancel.setMaximumSize(cancel.getPreferredSize());

        box.add(Box.createHorizontalGlue());
        box.add(save);
        box.add(Box.createHorizontalStrut(15));
        box.add(cancel);
        box.add(Box.createHorizontalGlue());

        window.getContentPane().add(pane, "Center");
        window.getContentPane().add(box, "South");
        window.setSize(512, 400);
    }

    public void setVisible(boolean b)
    {
        window.setVisible(b);
        return;
    }


    public void actionPerformed(ActionEvent e)
    {
        String cmd = e.getActionCommand();

        if (cmd.equals("save")) {
            // -- Save the miscellaneous options
            //
            DEBUG.print("MiscConfigFrame.actionPerformed: Saving... ");

            FileOutput.Line out = new FileOutput.Line("paperboy.conf");
            if (out.open()) {
                out.print( Config.getConfig().toString() );
                out.close();
                DEBUG.println("complete.");
            } else {
                DEBUG.println("failed.");
            }
            window.setVisible(false);

        } else if (cmd.equals("cancel")) {
            // -- Cancel changes and close window
            //
            window.setVisible(false);

        }
        return;
    }
}

