package org.bleb.paperboy.plugin;

import javax.swing.JComponent;

/**
 * Implemented by option types to allow them to be drawn onto a
 * pane.
 *
 * @version 0.01 (08-Mar-2000)
 **/
public interface Drawable
{
    /**
     * Return a subclass of <i>Component</i> suitable for placing into
     * a panel.
     *
     * @return Component representing object
     **/
    public JComponent getComponent();


    /**
     * Get the textual label for this field
     *
     * @return Textual label for this field
     **/
    public String getLabel();


    /**
     * Set the label for this field.
     *
     * @param l New label
     **/
    public void setLabel(String l);
}

