package org.bleb.paperboy.plugin;

import java.awt.*;
import javax.swing.*;

/**
 * A toggle option.
 *
 * @version 0.01 (08-Mar-2000)
 **/
public class OptionBoolean extends Option
{
    private Boolean   val;
    private JCheckBox button;

    public OptionBoolean()
    {
        super();
        if (getCreateGUI()) {
            button = new JCheckBox();
            setValue(Boolean.FALSE);
        } else {
            button = null;
        }
    }


    // -- Implements Option
    //
    public String getType() { return "boolean"; }
    public Object getValue() {
        if (button != null)
            val = new Boolean(button.isSelected());
        return val;
    }
    public void setValue(Object v)
    {
        val = (Boolean)v;
        if (button != null)
            button.setSelected(val.booleanValue());
    }
    public void setValue(String s)
    {
        setValue(new Boolean(s.equals("true")));
    }
    public void setLabel(String s)
    {
        super.setLabel(s);
        if (button != null)
            button.setText(s);
    }


    // -- Implements Drawable
    //
    public JComponent getComponent() { return button; }
}
