package org.bleb.paperboy.plugin;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * A text field
 *
 * @version 0.01 (08-Mar-2000)
 **/
public class OptionText extends Option
{
    private final static int COLS = 20;

    private String     val;
    private JPanel     component;
    private JLabel     label;
    private JTextField text;

    public OptionText()
    {
        super();
        if (getCreateGUI()) {
            component = new JPanel(new FlowLayout());
            label     = new JLabel("");
            text      = new JTextField("", COLS);
            component.add(label);
            component.add(text);
        } else {
            component = null;
            label     = null;
            text      = null;
        }
        val = "";
    }


    // -- Implements Option
    //
    public String getType() { return "text"; }
    public Object getValue() {
        if (text != null)
            val = text.getText();
        return val;
    }
    public void setValue(Object v)
    {
        setValue( (String)v );
    }
    public void setValue(String s)
    {
        val = s;
        if (text != null)
            text.setText(val);
    }
    public void setLabel(String s)
    {
        super.setLabel(s);
        if (label != null) {
            label.setText(s);
            label.setMaximumSize(label.getPreferredSize());
        }
    }


    // -- Implements Drawable
    //
    public JComponent getComponent() { return component; }
}

