package org.bleb.paperboy.rule;

import org.bleb.paperboy.util.*;
import java.util.*;
import java.io.*;

public class NodeTest
{
    public static void main(String argv[]) throws ParseException
    {
        NodeTest n = new NodeTest();
        return;
    }
    
    
    public NodeTest()
    {
        String text = "Andrew F. is <i>currently</i> on a systems sponsorship\n" +
                      "within FMC. Andrew is really cool etc. etc. and andrew\n"+
                      "is someone that everyone named andrew should be called!\n"+
                      "For <a href=moo.html>this</a> reason...";

        try {
            Rule r = Rule.getRule("andrew NEAR sponsor");
            text = stripHTML(text).toLowerCase();
        
            System.out.println("Input (unHTMLified):\n" + text + "\n");
            System.out.println(r.toString() + "=" +
                               r.matches(text, new RuleConfig()));
        } catch (ParseException e) {
            System.out.println("Parse error: "+e.getMessage());
        }
        return;
    }
    
    
    public String stripHTML(String text)
    {
        StringBuffer b   = new StringBuffer(text);
        int          pos = -1;
        
        while ((pos = sbIndexOf(b, "<", pos + 1)) >= 0) {
            b.delete(pos, sbIndexOf(b, ">", pos + 1) + 1);
        }
        
        return b.toString();
    }
    
    
    public int sbIndexOf(StringBuffer b, String search, int start)
    {
        int pos       = start;
        int lenBuffer = b.length();
        int lenSearch = search.length();
        int found     = -1;
        
        try {
            while ((pos <= lenBuffer) && (found == -1)) {
                if (b.substring(pos, pos + lenSearch).equals(search)) {
                    found = pos;
                }
                pos++;
            }
        } catch (StringIndexOutOfBoundsException e) {
            found = -1;
        }
        
        return found;
    }
}



