package org.bleb.paperboy.util;

/**
 * An implementation of hashtable which can be initialised with an
 * array (like Perl).
 *
 * @version 1.00 (07-Jan-1999)
 **/
public class SectionTable extends java.util.Hashtable
{
    /**
     * Takes an array of the form <code>(key1, value1, key2, value2, ...,
     * keyN, valueN)</code> and creates a hashtable using those values.
     **/
    public SectionTable(String[] hash)
    {
        super();
        
        for (int i=0; i<hash.length; i += 2) {
            this.put(hash[i], hash[i+1]);
        }
    }
    
    
    /**
     * Returns the value associated with a key <em>as a String</em> and
     * so doesn't require casting.
     *
     * @param key String containing a key
     * @returns String value associated with this key
     **/
    public String get(String key)
    {
        return (String)super.get(key);
    }
}
