package org.bleb.paperboy.util;

/**
 * Interface for allowing classes to be tested.
 *
 * @version 1.00 (07-Nov-1999)
 **/
public interface Testable
{
    /**
     * Tests the class. This should return true if the implementation
     * passes the set of tests. Errors should be output on stderr in the
     * format <code>"|^^^" + message</code> allowing nice formatting and
     * processing by additional tools.
     *
     * <p>Attempts should be made to recover from failures and continue with
     * further tests.
     *
     * @return true if all the tests were completed successfully.
     **/
    public boolean test();
}
